Tool: create_instance
Creates an AlloyDB instance, which is a child resource of a cluster.
Requirements
- The cluster that the instance is being created in must exist and be in a READY state. You can use the
list_clusterstool to list all clusters in a project. - If you're trying to create a PRIMARY instance, then the cluster must not already have a PRIMARY instance.
- If you're trying to create a READ_POOL instance, then the cluster must already have a PRIMARY instance.
Usage
- Call
create_clusterto create a cluster if it doesn't exist. - Call
create_instanceto create an instance within the cluster. - This will return a long-running operation that indicates the progress of the instance creation.
- You can poll the status of the operation using the
get_operationtool. Generally the creation takes 5-10 minutes. - Once the long-running operation is complete, the instance will be in a READY state.
The following sample demonstrate how to use curl to invoke the create_instance MCP tool.
| Curl Request |
|---|
curl --location 'https://alloydb.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "create_instance", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Message for creating an instance.
CreateInstanceRequest
| JSON representation |
|---|
{ "parent": string, "instanceId": string, "type": string, "pscInstanceConfig": { object ( |
| Fields | |
|---|---|
parent |
Required. Identifier. The parent resource in which to create the instance. The value must have a format of projects/{project}/locations/{location}/clusters/{cluster_id}. - {project} is the project that the cluster resides in. This field can be specified either as: - Project ID: An alphanumeric string that can consist of lowercase letters, numerical digits, or dash ("-") characters. - Project number: A valid base-10 encoded positive integer. - {location} is the Google Cloud region that the cluster resides in. Regions will have format like "us-central1" or "us-west2". - {cluster_id} is the ID of cluster. It should be an alphanumeric string that can consist of lowercase letters, numerical digits, or dash ("-") characters. The field is REQUIRED. |
instanceId |
Required. The instance ID is the unique user-assigned ID of the instance. It should be an alphanumeric string that can consist of lowercase letters, numerical digits, or dash characters ("-"). This field is REQUIRED. |
type |
Optional. The type of the instance. The allowed values are: - PRIMARY - An AlloyDB instance that will accept both read and write Postgres transactions. You can have only one primary instance per cluster. - READ_POOL - An AlloyDB instance that will only accept read Postgres transactions. You can have multiple read pool instances per cluster, but they can only be created after the primary instance has been created. This field is OPTIONAL. If unspecified, it will default to PRIMARY. |
pscInstanceConfig |
Optional. The configuration for Private Service Connect (PSC) for the instance. If automatic creation of PSC endpoints is desired, then configs for PSC auto connections must be specified. If unspecified, PSC endpoints will need to be created manually. This field is OPTIONAL. |
authorizedExternalNetworks[] |
Optional. A list of CIDR ranges that are authorized to connect to public IP. Authorized external networks are only allowed for instances with public IP enabled. This field is OPTIONAL. |
Union field
|
|
cpuCount |
Optional. The number of CPUs for the instance. If unspecified, it will default to 4. This field is OPTIONAL. |
Union field
|
|
machineType |
Optional. The machine type of the instance. If unspecified, it will default to n2-highmem-4. This field is OPTIONAL. |
Union field
|
|
readPoolNodeCount |
Optional. The number of read pool nodes for the instance. If unspecified, it will default to 1. This field is OPTIONAL. |
Union field
|
|
dbIamAuthentication |
Optional. Enables DB IAM authentication for this instance. Sets the "alloydb.iam_authentication" db flag to "on"/"off". This field is OPTIONAL. If unspecified, it will default to true. |
Union field
|
|
enablePublicIp |
Optional. Enables Public IP for this instance. Enabling public IP requires having the database flag |
PscInstanceConfig
| JSON representation |
|---|
{ "serviceAttachmentLink": string, "allowedConsumerProjects": [ string ], "pscDnsName": string, "pscInterfaceConfigs": [ { object ( |
| Fields | |
|---|---|
serviceAttachmentLink |
Output only. The service attachment created when Private Service Connect (PSC) is enabled for the instance. The name of the resource will be in the format of |
allowedConsumerProjects[] |
Optional. List of consumer projects that are allowed to create PSC endpoints to service-attachments to this instance. |
pscDnsName |
Output only. The DNS name of the instance for PSC connectivity. Name convention: |
pscInterfaceConfigs[] |
Optional. Configurations for setting up PSC interfaces attached to the instance which are used for outbound connectivity. Only primary instances can have PSC interface attached. Currently we only support 0 or 1 PSC interface. |
pscAutoConnections[] |
Optional. Configurations for setting up PSC service automation. |
PscInterfaceConfig
| JSON representation |
|---|
{ "networkAttachmentResource": string } |
| Fields | |
|---|---|
networkAttachmentResource |
The network attachment resource created in the consumer network to which the PSC interface will be linked. This is of the format: "projects/${CONSUMER_PROJECT}/regions/${REGION}/networkAttachments/${NETWORK_ATTACHMENT_NAME}". The network attachment must be in the same region as the instance. |
PscAutoConnectionConfig
| JSON representation |
|---|
{ "consumerProject": string, "consumerNetwork": string, "ipAddress": string, "status": string, "consumerNetworkStatus": string } |
| Fields | |
|---|---|
consumerProject |
The consumer project to which the PSC service automation endpoint will be created. |
consumerNetwork |
The consumer network for the PSC service automation, example: "projects/vpc-host-project/global/networks/default". The consumer network might be hosted a different project than the consumer project. |
ipAddress |
Output only. The IP address of the PSC service automation endpoint. |
status |
Output only. The status of the PSC service automation connection. Possible values: "STATE_UNSPECIFIED" - An invalid state as the default case. "ACTIVE" - The connection has been created successfully. "FAILED" - The connection is not functional since some resources on the connection fail to be created. "CREATING" - The connection is being created. "DELETING" - The connection is being deleted. "CREATE_REPAIRING" - The connection is being repaired to complete creation. "DELETE_REPAIRING" - The connection is being repaired to complete deletion. |
consumerNetworkStatus |
Output only. The status of the service connection policy. Possible values: "STATE_UNSPECIFIED" - Default state, when Connection Map is created initially. "VALID" - Set when policy and map configuration is valid, and their matching can lead to allowing creation of PSC Connections subject to other constraints like connections limit. "CONNECTION_POLICY_MISSING" - No Service Connection Policy found for this network and Service Class "POLICY_LIMIT_REACHED" - Service Connection Policy limit reached for this network and Service Class "CONSUMER_INSTANCE_PROJECT_NOT_ALLOWLISTED" - The consumer instance project is not in AllowedGoogleProducersResourceHierarchyLevels of the matching ServiceConnectionPolicy. |
Output Schema
This resource represents a long-running operation that is the result of a network API call.
Operation
| JSON representation |
|---|
{ "name": string, "metadata": { "@type": string, field1: ..., ... }, "done": boolean, // Union field |
| Fields | |
|---|---|
name |
The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the |
metadata |
Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any. An object containing fields of an arbitrary type. An additional field |
done |
If the value is |
Union field result. The operation result, which can be either an error or a valid response. If done == false, neither error nor response is set. If done == true, exactly one of error or response can be set. Some services might not provide the result. result can be only one of the following: |
|
error |
The error result of the operation in case of failure or cancellation. |
response |
The normal, successful response of the operation. If the original method returns no data on success, such as An object containing fields of an arbitrary type. An additional field |
Any
| JSON representation |
|---|
{ "typeUrl": string, "value": string } |
| Fields | |
|---|---|
typeUrl |
Identifies the type of the serialized Protobuf message with a URI reference consisting of a prefix ending in a slash and the fully-qualified type name. Example: type.googleapis.com/google.protobuf.StringValue This string must contain at least one The prefix is arbitrary and Protobuf implementations are expected to simply strip off everything up to and including the last All type URL strings must be legal URI references with the additional restriction (for the text format) that the content of the reference must consist only of alphanumeric characters, percent-encoded escapes, and characters in the following set (not including the outer backticks): In the original design of |
value |
Holds a Protobuf serialization of the type described by type_url. A base64-encoded string. |
Status
| JSON representation |
|---|
{ "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } |
| Fields | |
|---|---|
code |
The status code, which should be an enum value of |
message |
A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the |
details[] |
A list of messages that carry the error details. There is a common set of message types for APIs to use. An object containing fields of an arbitrary type. An additional field |
Tool Annotations
Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ❌ | Open World Hint: ❌